<?php

// -----------------------------------------------
//   設定
// -----------------------------------------------
// TypeKeyトークン
$type_key_token = 'abcdef';


// -----------------------------------------------
//   ログイン用ページのURIを取得する
// -----------------------------------------------
function getLoginURI($callback_uri)
{
  global $type_key_token;
  return 'https://www.typekey.com/t/typekey/login?'
    . 't=' . $type_key_token . '&need_email=1&_return=' . $callback_uri . '&v=1.1';
}


// -----------------------------------------------
//   ログインIDを取得する
// -----------------------------------------------
function getUserID()
{
  global $type_key_token;

  // パラメータを取得する
  $params = array();
  foreach (array('email', 'name', 'nick', 'ts', 'sig') as $key) {
    $params[$key] = $_GET[$key];
  }

  // 署名を検証する
  if (_verify($params)) {
    return $params['name'];
  } else {
    return null;
  }
}


// -----------------------------------------------
//   署名を検証する
// -----------------------------------------------
function _verify($params)
{
  global $type_key_token;

  // 公開鍵を取得する
  $fp = fopen('http://www.typekey.com/extras/regkeys.txt', 'rb');
  if (!$fp) {
    // エラー
    return null;
  }

  // 読み込む
  $data = "";
  while (!feof($fp)) {
    $data .= fread($fp, 8192);
  }
  fclose($fp);

  // ファイルをパースする
  $dsa_keys = array();
  foreach (explode(' ', $data) as $field) {
    list($key, $value) = explode(' ', $field, 2);
    $dsa_keys[$key] = trim($value);
  }

  // 署名された基の文字列を用意する
  $message = implode('::', array(
    $params['email'],
    $params['name'],
    $params['nick'],
    $params['ts'],
    $type_key_token));

  // DSAを検証する
  include_once 'Security/DSA.php';
  return Security_DSA::verify($message, $params['sig'], $dsa_keys);
}


// -----------------------------------------------
//   出力部
// -----------------------------------------------
// コールバックの呼び出しである
if (isset($_GET['sig'])) {
  // ログイン名を取得する
  $user_id = getUserID();

  // 取得に成功したか
  if ($user_id) {
    print 'あなたのTypeKeyログイン名は ' . $user_id . 'ですね';
  } else {
    print '認証に失敗しました';
  }
} else {
  // ログイン用ページのURIを取得する
  $login_uri = getLoginURI();

  // 出力する
  print '<a href="' . $login_uri . '">認証はこちらへ</a>';
}

?>
