<?php

// PEARのXML_RPCライブラリを使用する
require_once 'XML/RPC.php';

// パラメータ
$params = array(
  new XML_RPC_Value('http://www.example.com/', 'string'),
  new XML_RPC_Value('http://www.example.net/', 'string'),
);

// メッセージ
$message = new XML_RPC_Message('bookmark.getCount', $params);

// リクエスト先
$client  = new XML_RPC_Client('/xmlrpc', 'b.hatena.ne.jp');

// リクエストを送信する
$result  = $client->send($message);

// エラー処理
if (!$result) {
  echo 'Communication error: ' . $client->errstr;
  exit;
}

// XML-RPCでエラーが発生しているか
if (!$result->faultCode()) {
  // エラーは発生していないので返値を表示する
  $value = $result->value();
  $data  = XML_RPC_decode($value);
  var_dump($data);
} else {
  // エラーの内容を表示する
  echo 'Fault Code: ' . $result->faultCode() . "<br />\n";
  echo 'Fault Reason: ' . $result->faultString() . "<br />\n";
}

?>
