<?php

// APIのリクエストURI
$api_base = 'http://zuzara.dyndns.org/api/koshian';

// -----------------------------------------------
//   キーワードを抽出する
// -----------------------------------------------
function getKeywords()
{
  global $api_base;

  // APIへアクセスする
  include_once 'HTTP/Client.php';
  $http_client = new HTTP_Client();
  $result_code = $http_client->post($api_base, array('q' => $_POST['body']));
  if ($result_code != 200) {
    // エラー
    return null;
  }
  $response = $http_client->currentResponse();

  // XMLのパースをする
  $simplexml = simplexml_load_string($response['body']);

  // 回数を数える
  $data = array();
  foreach ($simplexml->Result as $id => $word) {
    $id = (int)$word->attributes()->id;
    if (isset($data[$id])) {
      $data[$id]['count']++;
    } else {
      $data[$id] = array(
        'count' => 1,
        'word'  => $word,
      );
    }
  }

  // 頻出順にソートする
  uasort($data, arraySort);

  // 配列を返す
  array_splice($data, 3);
  return $data;
}

// -----------------------------------------------
//   頻出順にソートするコールバック関数
// -----------------------------------------------
function arraySort($a, $b)
{
  // カウント値の大きい方が前になるようにする
  if ($a['count'] < $b['count']) {
    return 1;
  } else if ($a['count'] == $b['count']) {
    return 0;
  } else {
    return -1;
  }
}

// -----------------------------------------------
//   出力部
// -----------------------------------------------
// 文章が入力されている
if (isset($_POST['body'])) {
  $keywords = getKeywords();
}

// HTML部
?><form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
  <textarea name="body" cols="60" rows="10"><?php echo htmlspecialchars($_POST['body']); ?></textarea>
  <input type="submit" value="submit" />
  <p>Keywords:<?php
// 上位3つのキーワードを出力する
foreach($keywords as $id => $a) {
  echo ' ' . $a['word'] . '(' . $a['count'] . ')';
}
?></p>
</form>
