<?php
$postcode = $_GET['postcode'];

//クエリが正常か確認
if (!preg_match("/^\d{7}$/", $postcode)) {
    $res = array("error" => "Invalid Query.");
    header('X-JSON: '.json_encode($res));
    exit;
}

require_once "XML/RPC.php";

$hostname = "yubin.senmon.net";
$port = 80;
$path = "/service/xmlrpc/";

$xmlrpc = new XML_RPC_client($path, $hostname, $port);

//メッセージの生成
$param = array(new XML_RPC_Value($postcode, "string"));
$message = new XML_RPC_Message("yubin.fetchAddressByPostcode", $param);
//メッセージ送信
$response = $xmlrpc->send($message);

//結果の処理
if (!$response->faultCode()) {
    //検索結果をJSONとして出力
    if ($response->value()) {
        $value = XML_RPC_decode($response->value());
        header("X-JSON: " . json_encode($value));
    }
} else {
    //エラー内容をJSONとして出力
    $res = array("error" => $response->faultString());
    header("X-JSON: " . json_encode($res));
}
?>
