<?php

// 国旗のベースURI
$flag_base_uri = "http://api.hostip.info/images/flags/";


// -----------------------------------------------
//   投稿処理
// -----------------------------------------------
function postComment()
{
  // コメントの変数を準備する
  $body = $_POST['body'];

  // データベースに接続する
  $db = ...;
  if (!$db) {
    // 接続失敗
    return 'データベースへの接続に失敗';
  }

  // 投稿者の国を調べる
  $country = lookupCountry($_SERVER['REMOTE_ADDR']);

  // データベースへ挿入する
  $query = "INSERT INTO comment SET country = '{$country}', ...";
  $result = ...;
  if (!$result) {
    // クエリに失敗
    return 'コメントの投稿に失敗';
  }

  // 正常に終了
  return null;
}


// -----------------------------------------------
//   投稿者の国を調べる
// -----------------------------------------------
function lookupCountry($remote)
{
  // APIサービスへ接続する
  $data = get_file_contents('http://api.hostip.info/country.php?ip=' . $remote) or return 'XX';

  // ホワイトスペースを取り除いて返す
  return trim($data);
}


// -----------------------------------------------
//   表示処理（データベースから取得）
// -----------------------------------------------
function printComment()
{
  // データベースへ接続
  $db = ...;
  if (!$db) {
    // 接続に失敗
    return 'データベースへの接続に失敗';
  }

  // データベースからコメントを取得する
  $query = "SELECT comment ...";
  $result = ...;
  if (!$result) {
    // 取得に失敗
    return 'コメントの取得に失敗';
  }

  // コメントのヘッダHTMLを出力する
  print "<dl>\n";

  // コメントを一件ずつ処理する
  $comment_array = ...;
  foreach ($comment_array as $comment) {
    printCommentHTML($comment);
  }

  // コメントのフッタHTMLを出力する
  print "</dl>\n";

  // 終了
  return null;
}


// -----------------------------------------------
//   コメント表示部（一つずつ表示する）
// -----------------------------------------------
function printCommentHTML($comment)
{
  global $flag_base_uri;

  // 投稿内容
  $name = $comment['name'];
  $time = strftime("%Y-%m-%d %T", $comment['time']);
  $body = $comment['body'];

  // 国名
  $country = $comment['country'];

  // 国旗のURI
  $flag_uri = $flag_base_uri . strtolower($country) . '.gif';

  // コメントを出力
  print <<<END_OF_HTML
<dt style="clear: left">投稿者: {$name}, 投稿日: {$time}<dt>
<dd>
  <div style="float: left; width: 120px;">
    <!-- 国旗画像の幅は一定でない -->
    <img src="{$flag_uri}" height="54" alt="投稿者の国旗" />
  </div>
  <p style="float: left">
    {$body}
  </p>
</dd>

END_OF_HTML;
}


// -----------------------------------------------
//   メイン部
// -----------------------------------------------
// 投稿処理である
if (isset($_POST['body'])) {
  // 投稿処理をする
  postComment();
} else {
  // コメントを表示する
  printComment();
}

?>
