<html>
<head>
<title>日の出/日の入りまでの時間</title>
</head>
<body>
<h1>日の出/日の入りまでの時間</h1>

<?php
//Sun APIを利用して太陽の出没の情報を取得する関数
function getSunInfo($time)
{
    $req = "http://www.earthtools.org/sun-1.0/";
    $req .= "35.7/135.8"; //場所は東京で決め打ち
    $req .= "/" . date("d", $time);
    $req .= "/" . date("m", $time);
    $req .= "/9/0";
    return simplexml_load_file($req);
}

// 日の出のUNIXタイムを返す関数
function getSunriseTime($sunInfo, $time)
{
    $sunriseTimeStr = $sunInfo->morning->sunrise;
    return strtotime(date("Y-m-d", $time) . " " . $sunriseTimeStr);
}

// 日の入りのUNIXタイムを返す関数
function getSunsetTime($sunInfo, $time)
{
    $sunsetTimeStr = $sunInfo->evening->sunset;
    return strtotime(date("Y-m-d", $time) . " " . $sunsetTimeStr);
}

// 時間を"hour:min:sec"の文字列に変換する関数
function timeRangeToString($range)
{
    $hour = (int)($range / 3600);
    $min = (int)(($range % 3600) / 60);
    $sec = (int)(($range % 3600) % 60);
    return $hour . "時間" . $min . "分" . $sec . "秒";
}

// 今日の出没情報を取得する
$now = time();
$todaySunInfo = getSunInfo($now);
$todaySunriseTime = getSunriseTime($todaySunInfo, $now);
$todaySunsetTime = getSunsetTime($todaySunInfo, $now);

// 出没までの時刻を求める。昼か夜かの分類によって場合分けする
$event = "";
$timeToEvent = 0;

if ($now < $todaySunriseTime) { // 夜(日付が変わってから日の出まで)
    $event = "日の出";
    $timeToEvent = $todaySunriseTime - $now;
} elseif ($now < $todaySunsetTime) { // 昼(日の出から日の入りまで)
    $event = "日の入り";
    $timeToEvent = $todaySunsetTime - $now;
}else{ // 夜(日の入りから日付が変わるまで)
    $event = "日の出";
    $timeToEvent = $tomorrowSunriseTime - ($now - 3600 * 24); // 一日前の日の出から概算する。やや不正確
}

$timeToEventStr = timeRangeToString($timeToEvent);

?>
<p>
  次の
  <strong><?php echo $event ?></strong>
  までの時間は
  <strong><?php echo $timeToEventStr ?></strong>
  です。
</p>
</body>
</html>

